using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;

namespace AutoSuppression
{
    class EnregistrementJob : SPFeatureReceiver
    {
        //Nom du job
        const string JobName = "AutoSuppression";
        /// <summary>
        /// Mthode appele lors de l'activation de la feature
        /// </summary>
        /// <param name="properties"></param>
        public override void FeatureActivated(SPFeatureReceiverProperties properties)
        {
            SPWeb TargetWeb = properties.Feature.Parent as SPWeb;
            //Suppression du job si il existe dj
            foreach (SPJobDefinition Job in TargetWeb.Site.WebApplication.JobDefinitions)
            {
                if (Job.Name == JobName)
                {
                    Job.Delete();
                    break;
                }
            }
            //Instanciation de notre job et passage des paramtres
            //dfinis dans feature.xml
            Suppression JobSuppression = new Suppression(JobName, TargetWeb.Site.WebApplication,
                properties.Definition.Properties["TargetSite"].Value,
                properties.Definition.Properties["TargetList"].Value,
                properties.Definition.Properties["MaxLifeTime"].Value);

            //Cration du schedule, dans notre cas, le job sera excut
            //toutes les 2 minutes
            SPMinuteSchedule JobSchedule = new SPMinuteSchedule();
            JobSchedule.BeginSecond = 0;
            JobSchedule.EndSecond = 59;
            JobSchedule.Interval = 2;
            JobSuppression.Schedule = JobSchedule;
            JobSuppression.Update();

        }
        /// <summary>
        /// Mthode appele lors de la dsactivation de la feature.
        /// </summary>
        /// <param name="properties"></param>
        public override void FeatureDeactivating(SPFeatureReceiverProperties properties)
        {
            SPWeb TargetWeb = properties.Feature.Parent as SPWeb;
            //Suppression du job
            foreach (SPJobDefinition Job in TargetWeb.Site.WebApplication.JobDefinitions)
            {
                if (Job.Name == JobName)
                {
                    Job.Delete();
                    break;
                }
            }
            
        }
        /// <summary>
        /// Mthode abstraite qu'il faut au minimum dclarer
        /// </summary>
        /// <param name="properties"></param>
        public override void FeatureInstalled(SPFeatureReceiverProperties properties)
        {
            
        }
        /// <summary>
        /// Mthode abstraite qu'il faut au minimum dclarer
        /// </summary>
        /// <param name="properties"></param>
        public override void FeatureUninstalling(SPFeatureReceiverProperties properties)
        {
            
        }

        
    }
}
